diff --git a/src/include/catalog/pg_proc.h b/src/include/catalog/pg_proc.h
index 96f43fe..ff1f04f 100644
--- a/src/include/catalog/pg_proc.h
+++ b/src/include/catalog/pg_proc.h
@@ -46,6 +46,7 @@ CATALOG(pg_proc,1255) BKI_BOOTSTRAP BKI_ROWTYPE_OID(81) BKI_SCHEMA_MACRO
 	bool		proisagg;		/* is it an aggregate? */
 	bool		proiswindow;	/* is it a window function? */
 	bool		prosecdef;		/* security definer */
+	bool		proleakproof;	/* is it a leak-proof function? */
 	bool		proisstrict;	/* strict with respect to NULLs? */
 	bool		proretset;		/* returns a set? */
 	char		provolatile;	/* see PROVOLATILE_ categories below */
@@ -77,7 +78,7 @@ typedef FormData_pg_proc *Form_pg_proc;
  *		compiler constants for pg_proc
  * ----------------
  */
-#define Natts_pg_proc					26
+#define Natts_pg_proc					27
 #define Anum_pg_proc_proname			1
 #define Anum_pg_proc_pronamespace		2
 #define Anum_pg_proc_proowner			3
@@ -89,21 +90,22 @@ typedef FormData_pg_proc *Form_pg_proc;
 #define Anum_pg_proc_proisagg			9
 #define Anum_pg_proc_proiswindow		10
 #define Anum_pg_proc_prosecdef			11
-#define Anum_pg_proc_proisstrict		12
-#define Anum_pg_proc_proretset			13
-#define Anum_pg_proc_provolatile		14
-#define Anum_pg_proc_pronargs			15
-#define Anum_pg_proc_pronargdefaults	16
-#define Anum_pg_proc_prorettype			17
-#define Anum_pg_proc_proargtypes		18
-#define Anum_pg_proc_proallargtypes		19
-#define Anum_pg_proc_proargmodes		20
-#define Anum_pg_proc_proargnames		21
-#define Anum_pg_proc_proargdefaults		22
-#define Anum_pg_proc_prosrc				23
-#define Anum_pg_proc_probin				24
-#define Anum_pg_proc_proconfig			25
-#define Anum_pg_proc_proacl				26
+#define Anum_pg_proc_proleakproof		12
+#define Anum_pg_proc_proisstrict		13
+#define Anum_pg_proc_proretset			14
+#define Anum_pg_proc_provolatile		15
+#define Anum_pg_proc_pronargs			16
+#define Anum_pg_proc_pronargdefaults	17
+#define Anum_pg_proc_prorettype			18
+#define Anum_pg_proc_proargtypes		19
+#define Anum_pg_proc_proallargtypes		20
+#define Anum_pg_proc_proargmodes		21
+#define Anum_pg_proc_proargnames		22
+#define Anum_pg_proc_proargdefaults		23
+#define Anum_pg_proc_prosrc				24
+#define Anum_pg_proc_probin				25
+#define Anum_pg_proc_proconfig			26
+#define Anum_pg_proc_proacl				27
 
 /* ----------------
  *		initial contents of pg_proc
diff --git a/src/include/catalog/pg_proc.h b/src/include/catalog/pg_proc.h
index 96f43fe..ff1f04f 100644
--- a/src/include/catalog/pg_proc.h
+++ b/src/include/catalog/pg_proc.h
@@ -4356,3 +4358,4 @@ DESCR("fetch the Nth row value");
 #define PROARGMODE_TABLE	't'
 
 #endif   /* PG_PROC_H */
+
diff --git a/src/include/catalog/pg_proc_fn.h b/src/include/catalog/pg_proc_fn.h
index 09d779f..1d7fb4e 100644
--- a/src/include/catalog/pg_proc_fn.h
+++ b/src/include/catalog/pg_proc_fn.h
@@ -28,6 +28,7 @@ extern Oid ProcedureCreate(const char *procedureName,
 				bool isAgg,
 				bool isWindowFunc,
 				bool security_definer,
+				bool isLeakProof,
 				bool isStrict,
 				char volatility,
 				oidvector *parameterTypes,
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index a4fb3b5..d0dfc50 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -707,6 +707,8 @@ typedef struct RangeTblEntry
 	 */
 	Query	   *subquery;		/* the sub-query */
 
+	bool		security_barrier;	/* Was a security barrier view? */
+
 	/*
 	 * Fields valid for a join RTE (else NULL/zero):
 	 *
@@ -2342,6 +2344,7 @@ typedef struct ViewStmt
 	List	   *aliases;		/* target column names */
 	Node	   *query;			/* the SELECT query */
 	bool		replace;		/* replace an existing view? */
+	List	   *options;		/* options from WITH clause */
 } ViewStmt;
 
 /* ----------------------
diff --git a/src/include/parser/kwlist.h b/src/include/parser/kwlist.h
index 12c2faf..44cbc5f 100644
--- a/src/include/parser/kwlist.h
+++ b/src/include/parser/kwlist.h
@@ -215,6 +215,7 @@ PG_KEYWORD("last", LAST_P, UNRESERVED_KEYWORD)
 PG_KEYWORD("lc_collate", LC_COLLATE_P, UNRESERVED_KEYWORD)
 PG_KEYWORD("lc_ctype", LC_CTYPE_P, UNRESERVED_KEYWORD)
 PG_KEYWORD("leading", LEADING, RESERVED_KEYWORD)
+PG_KEYWORD("leakproof", LEAKPROOF, UNRESERVED_KEYWORD)
 PG_KEYWORD("least", LEAST, COL_NAME_KEYWORD)
 PG_KEYWORD("left", LEFT, TYPE_FUNC_NAME_KEYWORD)
 PG_KEYWORD("level", LEVEL, UNRESERVED_KEYWORD)
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
index 173dc16..104e887 100644
--- a/src/include/utils/rel.h
+++ b/src/include/utils/rel.h
@@ -168,7 +168,7 @@ typedef struct RelationData
 
 /*
  * StdRdOptions
- *		Standard contents of rd_options for heaps and generic indexes.
+ *		Standard contents of rd_options for heaps, views and generic indexes.
  *
  * RelationGetFillFactor() and RelationGetTargetPageFreeSpace() can only
  * be applied to relations that use this format or a superset for
@@ -194,6 +194,7 @@ typedef struct StdRdOptions
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
 	AutoVacOpts autovacuum;		/* autovacuum-related options */
+	bool		security_barrier;	/* performs as security-barrier view */
 } StdRdOptions;
 
 #define HEAP_MIN_FILLFACTOR			10
@@ -222,6 +223,14 @@ typedef struct StdRdOptions
 	(BLCKSZ * (100 - RelationGetFillFactor(relation, defaultff)) / 100)
 
 /*
+ * RelationIsSecurityView
+ *             Returns whether the relation is security view, or not
+ */
+#define RelationIsSecurityView(relation)	\
+	((relation)->rd_options ?				\
+	 ((StdRdOptions *) (relation)->rd_options)->security_barrier : false)
+
+/*
  * RelationIsValid
  *		True iff relation descriptor is valid.
  */
diff --git a/src/test/regress/input/create_function_1.source b/src/test/regress/input/create_function_1.source
index a72dd98..6a015db 100644
--- a/src/test/regress/input/create_function_1.source
+++ b/src/test/regress/input/create_function_1.source
@@ -52,6 +52,12 @@ CREATE FUNCTION set_ttdummy (int4)
         AS '@libdir@/regress@DLSUFFIX@'
         LANGUAGE C STRICT;
 
+CREATE FUNCTION leakproof_dummy ()
+        RETURNS int4
+        LEAKPROOF
+        AS 'SELECT 1'
+        LANGUAGE SQL;
+
 -- Things that shouldn't work:
 
 CREATE FUNCTION test1 (int) RETURNS int LANGUAGE SQL
diff --git a/src/test/regress/output/create_function_1.source b/src/test/regress/output/create_function_1.source
index 61b87ed..1604378 100644
--- a/src/test/regress/output/create_function_1.source
+++ b/src/test/regress/output/create_function_1.source
@@ -47,6 +47,11 @@ CREATE FUNCTION set_ttdummy (int4)
         RETURNS int4
         AS '@libdir@/regress@DLSUFFIX@'
         LANGUAGE C STRICT;
+CREATE FUNCTION leakproof_dummy ()
+        RETURNS int4
+        LEAKPROOF
+        AS 'SELECT 1'
+        LANGUAGE SQL;
 -- Things that shouldn't work:
 CREATE FUNCTION test1 (int) RETURNS int LANGUAGE SQL
     AS 'SELECT ''not an integer'';';
diff --git a/src/test/regress/sql/create_view.sql b/src/test/regress/sql/create_view.sql
index 86cfc51..5a619c9 100644
--- a/src/test/regress/sql/create_view.sql
+++ b/src/test/regress/sql/create_view.sql
@@ -191,6 +191,30 @@ AND NOT EXISTS (SELECT g FROM tbl4 LEFT JOIN tmptbl ON tbl4.h = tmptbl.j);
 SELECT count(*) FROM pg_class where relname LIKE 'mytempview'
 And relnamespace IN (SELECT OID FROM pg_namespace WHERE nspname LIKE 'pg_temp%');
 
+--Should work correctly to leaky-view scenario
+CREATE TABLE lvtest1 (a int, b text);
+CREATE TABLE lvtest2 (x int, y text);
+
+INSERT INTO lvtest1 VALUES (10, 'aaa'), (11, 'bbb'), (12, 'ccc'), (13, 'ddd');
+INSERT INTO lvtest2 VALUES (11, 'xxx'), (12, 'yyy'), (13, 'zzz'), (14, 'xyz');
+
+CREATE OR REPLACE VIEW leaky_v1 WITH (security_barrier=true) AS
+	   SELECT * FROM lvtest1 JOIN lvtest2 ON a = x WHERE a % 2 = 0;	-- OK
+CREATE OR REPLACE VIEW leaky_v2 WITH (security_barrier=false) AS
+	   SELECT * FROM lvtest1 JOIN lvtest2 ON a = x WHERE a % 2 = 1;	-- OK
+CREATE OR REPLACE VIEW leaky_v3 WITH (invalid_option=1234) AS
+	   SELECT * FROM lvtest1 JOIN lvtest2 ON a = x WHERE a % 2 = 1;	-- Fail
+SELECT relname, reloptions FROM pg_class WHERE relname like 'leaky_v%';
+
+ALTER TABLE leaky_v1 RESET ( security_barrier );
+ALTER TABLE leaky_v2 SET ( security_barrier );
+SELECT relname, reloptions FROM pg_class WHERE relname like 'leaky_v%';
+
+-- reloptions should be reset
+CREATE OR REPLACE VIEW leaky_v2 AS
+	    SELECT * FROM lvtest1 JOIN lvtest2 ON a = x WHERE a % 2 = 1;
+SELECT relname, reloptions FROM pg_class WHERE relname like 'leaky_v%';
+
 DROP SCHEMA temp_view_test CASCADE;
 DROP SCHEMA testviewschm2 CASCADE;
 
